package net.kokozo.android.nfc.edyviewer;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.Calendar;

import android.app.Activity;
import android.content.Intent;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.NfcF;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class edyviewer extends Activity {
	private TextView tv1;
	private TextView tv2;
    private StringBuffer sb1 = new StringBuffer();
    private StringBuffer sb2 = new StringBuffer();

    private final int MENU_ID1 = Menu.FIRST;
    private int cont_flg = 0;
    private byte[] idm =  new byte[8];
    private byte[] edyResult = new byte[16*8];
    private final byte[] polling_common_area_command = new byte[]{(byte)0x06, (byte)0x00, (byte) 0xFE, (byte) 0x00, (byte)0x00, (byte)0x0F};
    private byte[] request_service_edy_no_command = new byte[]{(byte)0x0d, (byte)0x02, (byte) 0x00, (byte) 0x00, (byte)0x00, (byte)0x00, (byte) 0x00, (byte) 0x00, (byte)0x00, (byte)0x00,
    															(byte)0x01, (byte)0x0b, (byte)0x11};
    private byte[] read_wo_encryption_edy_command = new byte[]{(byte)0x22, (byte)0x06, (byte) 0x00, (byte) 0x00, (byte)0x00, (byte)0x00, (byte) 0x00, (byte) 0x00, (byte)0x00, (byte)0x00, 
    															(byte)0x03, (byte)0x0b, (byte)0x11, (byte)0x17, (byte)0x13, (byte)0x0f, (byte)0x17,
    															(byte)0x08, (byte)0x80, (byte)0x00, (byte)0x81, (byte)0x00, (byte)0x82, (byte)0x00, (byte)0x82, (byte)0x01, (byte)0x82, (byte)0x02, (byte)0x82, (byte)0x03, (byte)0x82, (byte)0x04, (byte)0x82, (byte)0x05};

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    	Intent intent = getIntent();
    	Tag tag = (Tag) intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
    	NfcF techF = NfcF.get(tag);
    	
        Button button = (Button) findViewById(R.id.button01);
        button.setOnClickListener(new View.OnClickListener() {
        	@Override
        	public void onClick(View v) {
				System.exit(RESULT_OK);
       		}
        });
    	
        tv1 = (TextView) this.findViewById(R.id.TextView01);
        tv2 = (TextView) this.findViewById(R.id.TextView02);

        byte[] responce = null;
    	
    	try {
    		techF.connect();
    		if(techF.isConnected()) {
        		responce = techF.transceive(polling_common_area_command);
        		for(int i = 0; i < 8; i++) {
        			idm[i] = responce[i+2];
        		}
        		sb2.append("Polling Sent Command: ");
        		sb2.append("\n");
        		for(int i = 0; i < polling_common_area_command.length; i++) {
        			sb2.append(String.format("%02X",polling_common_area_command[i]));
        		}
        		sb2.append("\n");
        		sb2.append("Polling Responce Packet: ");
        		sb2.append("\n");
        		for(int i = 0; i < responce.length; i++) {
        			sb2.append(String.format("%02X",responce[i]));
        		}
        		sb2.append("\n");
        		tv2.setText(sb2);
        		cont_flg = 1;
    		} else {
                sb1.append("FeliCa܂");
            	sb1.append("\n");
                tv1.setText(sb1);
                sb2.append("Polling Error: ");
            	sb2.append("\n");
                sb2.append("FeliCa܂");
            	sb2.append("\n");
        		sb2.append("Polling Sent Command: ");
        		sb2.append("\n");
        		for(int i = 0; i < polling_common_area_command.length; i++) {
        			sb2.append(String.format("%02X",polling_common_area_command[i]));
        		}
        		sb2.append("\n");
                tv2.setText(sb2);
                cont_flg = 0;
    		}
    	} catch (IOException e) {
            sb1.append("FeliCaꂽAEdył͂܂");
        	sb1.append("\n");
    		tv1.setText(sb1);
            sb2.append("Polling Error: ");
        	sb2.append("\n");
            sb2.append("FeliCaꂽAEdył͂܂");
        	sb2.append("\n");
    		sb2.append("Polling Sent Command: ");
    		sb2.append("\n");
    		for(int i = 0; i < polling_common_area_command.length; i++) {
    			sb2.append(String.format("%02X",polling_common_area_command[i]));
    		}
    		sb2.append("\n");
    		tv2.setText(sb2);
            cont_flg = 0;
    	} catch (Exception e) {
            sb2.append("Polling Exception: ");
        	sb2.append("\n");
            sb2.append(e.getMessage());
        	sb2.append("\n");
            tv2.setText(sb2);
            cont_flg = 0;
    	}

    	if(cont_flg == 1) {

    		byte[] responce2 = null;
    		for(int i = 0; i < 8; i++) {
    			request_service_edy_no_command[2+i] = idm[i];
    		}
    	
    		try {
    			if(techF.isConnected()) {
    				responce2 = techF.transceive(request_service_edy_no_command);

    				sb2.append("Request Service Sent Command: ");
    				sb2.append("\n");
    				for(int i = 0; i < request_service_edy_no_command.length; i++) {
    					sb2.append(String.format("%02X",request_service_edy_no_command[i]));
    				}
    				sb2.append("\n");
    				sb2.append("Request Service Responce Packet: ");
    				sb2.append("\n");
    				for(int i = 0; i < responce2.length; i++) {
    					sb2.append(String.format("%02X",responce2[i]));
    				}
    				sb2.append("\n");
    				sb2.append("Key Version: ");
    				sb2.append("\n");
    				for(int i = 11; i <= 12; i++) {
    					sb2.append(String.format("%02X",responce2[i]));
    				}
    				sb2.append("\n");
    				tv2.setText(sb2);
    				if((responce2[11] == (byte)0xFF) && (responce2[12] == (byte)0xFF)) {
    					sb1.append("Edył͂܂");
    					sb1.append("\n");
    					tv1.setText(sb1);
    					sb2.append("Edył͂܂");
    					sb1.append("\n");
    					tv2.setText(sb2);
    					cont_flg = 0;
    				} else {
    					cont_flg = 1;
    				}
    			} else {
    				sb1.append("FeliCa܂");
    				sb1.append("\n");
    				tv1.setText(sb1);
    				sb2.append("Request Service Error: ");
    				sb2.append("\n");
    				sb2.append("FeliCa܂");
    				sb2.append("\n");
    				sb2.append("Request Service Sent Command: ");
    				sb2.append("\n");
    				for(int i = 0; i < request_service_edy_no_command.length; i++) {
    					sb2.append(String.format("%02X",request_service_edy_no_command[i]));
    				}
    				sb2.append("\n");
    				tv2.setText(sb2);
    				cont_flg = 0;
    			}
    		} catch (IOException e) {
    			sb1.append("FeliCaꂽAEdył͂܂");
    			sb1.append("\n");
				tv1.setText(sb1);
    			sb2.append("Request Service Error: ");
    			sb2.append("\n");
    			sb2.append("FeliCaꂽAEdył͂܂");
    			sb2.append("\n");
				sb2.append("Request Service Sent Command: ");
				sb2.append("\n");
				for(int i = 0; i < request_service_edy_no_command.length; i++) {
					sb2.append(String.format("%02X",request_service_edy_no_command[i]));
				}
				sb2.append("\n");
				tv2.setText(sb2);
        		cont_flg = 0;
    		} catch (Exception e) {
    			sb2.append("Request Service Exception: ");
    			sb2.append("\n");
    			sb2.append(e.getMessage());
    			sb2.append("\n");
    			tv2.setText(sb2);
        		cont_flg = 0;
    		}
    	}

    	if(cont_flg == 1) {

    		byte[] responce3 = null;
    		for(int i = 0; i < 8; i++) {
    			read_wo_encryption_edy_command[2+i] = idm[i];
    		}
    	
    		try {
    			if(techF.isConnected()) {
    				responce3 = techF.transceive(read_wo_encryption_edy_command);

    				sb2.append("Read wo encryption Sent Command: ");
    				sb2.append("\n");
    				for(int i = 0; i < read_wo_encryption_edy_command.length; i++) {
    					sb2.append(String.format("%02X",read_wo_encryption_edy_command[i]));
    				}
    				sb2.append("\n");
    				sb2.append("Read wo encryption Responce Packet: ");
    				sb2.append("\n");
    				for(int i = 0; i < 13; i++) {
    					sb2.append(String.format("%02X",responce3[i]));
    				}
					sb2.append("\n");
    				for(int i = 13; i < responce3.length; i++) {
    					sb2.append(String.format("%02X",responce3[i]));
    					if(((i - 12) % 16) == 0) {
        					sb2.append("\n");
    					}
    				}
    				sb2.append("\n");
    				sb2.append("Read wo encryption Status flag 1: ");
    				sb2.append(String.format("%02X",responce3[10]));
    				sb2.append("\n");
    				sb2.append("Read wo encryption Status flag 2: ");
    				sb2.append(String.format("%02X",responce3[11]));
    				sb2.append("\n");
    				tv2.setText(sb2);
    				if(!((responce3[10] == (byte)0x00) && (responce3[11] == (byte)0x00))) {
    					sb1.append("ǂݏoɉ炩̃G[܂");
        				sb1.append("\n");
    					tv1.setText(sb1);
    					sb2.append("ǂݏoɉ炩̃G[܂");
        				sb2.append("\n");
    					tv2.setText(sb2);
    					cont_flg = 0;
    				} else {
    					for(int i = 0; i < 16 * 8; i++) {
    						edyResult[i] = responce3[13+i];
    					}
    					dispEdyResult(edyResult);
				cont_flg = 1;
    				}
    			} else {
    				sb1.append("FeliCa܂");
    				sb1.append("\n");
    				tv1.setText(sb1);
    				sb2.append("Read wo encryption Error: ");
    				sb2.append("\n");
    				sb2.append("FeliCa܂");
    				sb2.append("\n");
    				sb2.append("Read wo encryption Sent Command: ");
    				sb2.append("\n");
    				for(int i = 0; i < read_wo_encryption_edy_command.length; i++) {
    					sb2.append(String.format("%02X",read_wo_encryption_edy_command[i]));
    				}
    				sb2.append("\n");
    				tv2.setText(sb2);
    				cont_flg = 0;
    			}
    		} catch (IOException e) {
    			sb2.append("Read wo encryption Error: ");
    			sb2.append("\n");
    			sb2.append("FeliCa܂");
    			sb2.append("\n");
				sb2.append("Request Service Sent Command: ");
				sb2.append("\n");
				for(int i = 0; i < read_wo_encryption_edy_command.length; i++) {
					sb2.append(String.format("%02X",read_wo_encryption_edy_command[i]));
				}
				sb2.append("\n");
				tv2.setText(sb2);
        		cont_flg = 0;
    		} catch (Exception e) {
    			sb2.append("Read wo encryption Exception: ");
    			sb2.append("\n");
    			sb2.append(e.getMessage());
    			sb2.append("\n");
    			tv2.setText(sb2);
        		cont_flg = 0;
    		}
    	}

    	
    	try {
    		techF.close();
    	} catch (IOException e) {
            sb2.append("close IOException: ");
        	sb2.append("\n");
            sb2.append(e.getMessage());
        	sb2.append("\n");
            tv2.setText(sb2);
    	} catch (Exception e) {
            sb2.append("close Exception: ");
        	sb2.append("\n");
            sb2.append(e.getMessage());
        	sb2.append("\n");
            tv2.setText(sb2);
    	}
    }

    public boolean onCreateOptionsMenu(Menu menu) {
		boolean ret = super.onCreateOptionsMenu(menu);

		menu.add(0 , MENU_ID1 , Menu.NONE , "I");
		return ret;
	}

	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()) {
			case MENU_ID1:
				System.exit(RESULT_OK);
				return true;
			default:
				break;
		}
		return super.onOptionsItemSelected(item);
	}
	
	public void dispEdyResult(byte[] EdyResult) {
        sb1.append("Edyԍ: ");
		for(int i = 2; i <= 9 ; i++) {
			sb1.append(String.format("%02X",EdyResult[i]));
		}
    	sb1.append("\n");

    	sb1.append("Edyc: ");
        ByteBuffer bf = ByteBuffer.allocate(4);
        bf.put(EdyResult[19]);
        bf.put(EdyResult[18]);
        bf.put(EdyResult[17]);
        bf.put(EdyResult[16]);
		sb1.append(String.format("%05d",bf.getInt(0)));
    	sb1.append("~");
    	sb1.append("\n");

    	sb1.append("\n");
		sb1.append("@@@@ @@@@,  , @z@ , @c\n");
    	for(int i = 0; i < 6; i++) {
    		byte[] EdyHistory = new byte[16];
    		for(int j = 0; j < 16; j++) {
    			EdyHistory[j] = EdyResult[16 * (i + 2) + j]; 
    		}
    		dispEdyHistory(EdyHistory);
    		sb1.append("\n");
    	}

    	tv1.setText(sb1);
	}

	public void dispEdyHistory(byte[] EdyHistory) {
		
		// 
        ByteBuffer timebf = ByteBuffer.allocate(4);
        timebf.put(EdyHistory[4]);
        timebf.put(EdyHistory[5]);
        timebf.put(EdyHistory[6]);
        timebf.put(EdyHistory[7]);
        int timebfDiff = timebf.getInt(0);
        int dateDiff = timebfDiff >>> 17;
    	int timeDiff = (timebfDiff << 15) >>> 15;
    	
        Calendar historyDate = Calendar.getInstance();
        historyDate.set(2000, 0, 1, 0, 0, 0);
        historyDate.add(Calendar.DATE, dateDiff);
        sb1.append(String.format("%04d",historyDate.get(Calendar.YEAR)));
        sb1.append("/");
        sb1.append(String.format("%02d",historyDate.get(Calendar.MONTH) + 1));
        sb1.append("/");
        sb1.append(String.format("%02d",historyDate.get(Calendar.DATE)));
        sb1.append(", ");

        Calendar historyTime = Calendar.getInstance();
        historyTime.set(2000, 0, 1, 0, 0, 0);
        historyTime.add(Calendar.SECOND, timeDiff);
        sb1.append(String.format("%02d",historyTime.get(Calendar.HOUR_OF_DAY)));
        sb1.append(":");
        sb1.append(String.format("%02d",historyTime.get(Calendar.MINUTE)));
        sb1.append(":");
        sb1.append(String.format("%02d",historyTime.get(Calendar.SECOND)));
        sb1.append(", ");

        // ʔ
		//for(int i = 1; i <= 3; i++) {
		//	sb1.append(String.format("%02X",EdyHistory[i]));
		//}
		//sb1.append(", ");
		
        // 
		if(EdyHistory[0] == (byte)0x20) {
			sb1.append("x  ");
		} else if (EdyHistory[0] == (byte)0x02) {
			sb1.append("");
		} else if (EdyHistory[0] == (byte)0x04) {
			sb1.append("  ");
		} else {
			sb1.append("s  ");
		}
		sb1.append(", ");
		
		// z
        ByteBuffer bf1 = ByteBuffer.allocate(4);
        bf1.put(EdyHistory[8]);
        bf1.put(EdyHistory[9]);
        bf1.put(EdyHistory[10]);
        bf1.put(EdyHistory[11]);
		sb1.append(String.format("%05d",bf1.getInt(0)));
    	sb1.append("~");
		sb1.append(", ");
		
		// c
        ByteBuffer bf2 = ByteBuffer.allocate(4);
        bf2.put(EdyHistory[12]);
        bf2.put(EdyHistory[13]);
        bf2.put(EdyHistory[14]);
        bf2.put(EdyHistory[15]);
		sb1.append(String.format("%05d",bf2.getInt(0)));
    	sb1.append("~");
	}
}
